<?php
/************************************************************************
    This file is part of Desk-Kregator.

    Desk-Kregator is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Desk-Kregator is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Desk-Kregator.  If not, see <http://www.gnu.org/licenses/>.
*************************************************************************/

require_once("./system/modules/Desk-Kregator/php/lib.php");
require_once("./system/modules/Desk-Kregator/php/simplepie.inc.php");

$o = new stdClass;

if( !isset($_POST['idFeed']) || trim($_POST['idFeed']) == '' ) {

$o->success = false;
$o->message = 'No feed';
echo json_encode($o);
exit;

}

$id_feed = trim($_POST['idFeed']);
$cache = trim($_POST['cache']);

$old_nb_items = get_total($id_feed, $member_id);

// Get URL of the feed
$s = 'SELECT url_feed FROM deskKregator_dir WHERE id=\''.$id_feed.'\' AND userID=\''.$member_id.'\'';
$r = mysql_query($s) or die("{'success':false, 'msg':'Sql error :".mysql_error()."'}");
$a = mysql_fetch_object($r);

$url_feed = $a->url_feed;

$feed = new SimplePie();

if (get_magic_quotes_gpc()) {
   $url_feed = stripslashes($url_feed);
}

$feed->set_feed_url($url_feed);
$feed->enable_order_by_date(false);


$feed->set_cache_location('./system/cache/memberID_'.$member_id);

// Cache
if( $cache == 'off' ) {
  $feed->enable_cache(false);
} else {
  $feed->enable_cache();
}

$feed->init();
$feed->handle_content_type();

if( $feed->error() ) {

$o->success = false;
$o->message = 'Error when analyze feed. ' . $feed->error();
echo json_encode($o);
exit;

}


function item_present($url, $titre) {
global $id_feed;
global $member_id;

$s = 'SELECT id FROM deskKregator_items WHERE url=\''.mysql_real_escape_string($url).'\' AND titre=\''.mysql_real_escape_string($titre).'\' AND id_feed=\''.$id_feed.'\' AND userID=\''.$member_id.'\'';
$r = mysql_query($s) or die("{'success':false, 'msg':'Sql error :".mysql_error()."'}");
$nb = mysql_num_rows($r);

if( $nb == 0 ) { return false; }
else { return true; }

} // item_present

// Insert new article

if ($feed->data):
  $items = $feed->get_items();
  foreach($items as $item):

$auteur_1 = $item->get_author();

if( !isset( $auteur_1 ) ) $auteur = '-';
else $auteur = $auteur_1->get_name();

if( !item_present($item->get_permalink(), $item->get_title()) ) {



// images relatives
$contenu = $item->get_content();
$contenu = str_replace('src="/', 'src="'.$feed->get_link(), $contenu);

// Enclosure management

$enclosures = $item->get_enclosures();
$nb_enclosures = count($enclosures);
$nb_real_enclosures = 0;
$enclosure_contenu = '';

if( $nb_enclosures > 0 ) {

$enclosure_contenu .= '<h1 class="DeskKregator-enclosure">Media</h1><table>';

foreach($enclosures as $enclosure) {

$extension = strtolower(substr($enclosure->link, -3));

if( $enclosure->handler == 'mp3' && $extension == 'mp3' ) {

  $nb_real_enclosures++;
  $enclosure_contenu .= get_enclosure('mp3', $enclosure->link, 0, 0, $enclosure->title);

} else if( $enclosure->handler == 'fmedia' && $extension == 'flv'  ) {

  $nb_real_enclosures++;
  $enclosure_contenu .= get_enclosure('flv', $enclosure->link, $enclosure->height, $enclosure->width, $enclosure->title);

} else if ( $enclosure->type == 'application/pdf' ) {

  $nb_real_enclosures++;
  $enclosure_contenu .= get_enclosure('pdf', $enclosure->link, 0, 0, $enclosure->title, $enclosure->type);

} else if ( $enclosure->type != 'application/postscript'
         && $enclosure->type != 'image/gif'
         && $enclosure->type != 'image/png'
         && $enclosure->type != 'image/jpeg'
         && $enclosure->type != 'image/bmp' ) {
  $nb_real_enclosures++;
  $enclosure_contenu .= get_enclosure('other', $enclosure->link, $enclosure->height, $enclosure->width, $enclosure->title, $enclosure->type);
}
} // End foreach

$enclosure_contenu .= '</table>';

} // There is an enclosure

// Add enclosure
if( $nb_real_enclosures != 0 ) {
$contenu = $contenu.$enclosure_contenu;
}

$s = '
INSERT INTO
deskKregator_items

(id_feed, titre, date, auteur, summary, description, url, userID)
VALUES (
\''.$id_feed.'\',
\''.mysql_real_escape_string($item->get_title()).'\',
\''.$item->get_date('Y-m-d H:i:s').'\',
\''.mysql_real_escape_string($auteur).'\',
\''.summary(mysql_real_escape_string($contenu), '100').'\',
\''.mysql_real_escape_string($contenu).'\',
\''.$item->get_permalink().'\',
\''.$member_id.'\'
)';

if( !mysql_query($s)) {

$o->success = false;
$o->message = 'Error while inserting an article. Sql error : '.mysql_error();
echo json_encode($o);
exit;

}

}

  endforeach;
endif;

$new_nb_items = get_total($id_feed, $member_id);

$o->success = true;
$o->unseen = get_unseen($id_feed, $member_id);
$o->old_nb_item = $old_nb_items;
$o->new_nb_item = $new_nb_items;

echo json_encode($o);
exit;

?>